'
'CONWAYs Spiel des Lebens
'========================

' Bedeutung und Regeln : https://de.wikipedia.org/wiki/Conways_Spiel_des_Lebens
' Programmer :   Klaus Brock    klausbrock@hotmail.de       02/2017
' Compile    :   Windows-Console (FbEdit)

Dim Shared As Short i,j,ib,ih,iz,il,k,l,lb,lh,m,n,ix,jx,RegelTyp,fanz,istop,lebend,LivNbrs,breit,hoch,_
                    liox,reux,lioy,reuy,Vzmillsek,Splfd,ireg
Dim Shared As Integer igen,lincolor,circolor,totcolor,lebcolor,backcolor,fndx,MousePosX,MousePosY,MouseKeyState,_
                    scrb,scrh,scrct,xstart,ystart
Dim Shared As String steuer,Taste,Pfeil
Dim shared As BOOLEAN cnt 

'RegelTyp 3 : Anzahl lebender Nachbarn fuer ueberlebend :
Dim Shared As Short ueberleb (1 To 8) = { -1,-1,-1,-1,-1,-1,-1,-1 }
'RegelTyp 3 : Anzahl lebender Nachbarn fuer Geburt : 
Dim Shared As Short neugebor (1 To 8) = { -1,-1,-1,-1,-1,-1,-1,-1 } 
                      
  lincolor  = 7
  circolor  = 0
  totcolor  = 15
  lebcolor  = 4   ' fuer Initialbelegung, danach zyklisch
  backcolor = 14  ' initialer Spielfeldgatter Hintergrund 
Dim Shared As Integer farbe (1 To 13)  'Farben fuer fndx
  Farbe(1)  =  4              
  Farbe(2)  =  1          
  Farbe(3)  =  2             
  Farbe(4)  =  3             
  Farbe(5)  =  5              
  Farbe(6)  =  6             
  Farbe(7)  =  8              
  Farbe(8)  =  9               
  Farbe(9)  =  10               
  Farbe(10) =  11               
  Farbe(11) =  12               
  Farbe(12) =  13               
  Farbe(13) =  10 '14 ist schon backcolor              
      
Declare Sub StartWerteSetzen()
Declare Sub GitterLinienZeichnen()
Declare Sub BelebteZellenInit()
Declare Sub MainLoop()

Declare Sub CountLivingNeigbors()

' ... die Conway-"Welten" :
Declare Sub KlassischConway()
Declare Sub KopierWelt()
Declare Sub FreiDefWelt()

' ---

Declare Sub ZellGeburtInit()
Declare Sub ZellGeburt()
Declare Sub ZellTod()
Declare Sub ZellPos()
Declare Sub StopKey()
Declare Sub Ausgestorben()
Declare Sub ShowArray()

'------------------- Hauptprogramm ----------------------------------------------------------

Cls

randomize

StartWerteSetzen

'die gewuenschten Dimensionen (lh*lb) der internen Arbeits-Arrays sind jetzt bekannt :
'numW = aktuelles Feld   /  numFolg = Vormerkungen fuer Folgegeneration
Dim shared As BOOLEAN numW    (1 To lh, 1 To lb)  
Dim shared As BOOLEAN numFolg (1 To lh, 1 To lb) 

Do
  GitterLinienZeichnen
  BelebteZellenInit
  igen   = 1     '  Generation = ein Durchlauf ueber alle logischen Felder des Gatters
  MainLoop
Loop 



'-------------------  es folgen   Level   1   Sub's ----------------------------------------------------------


Sub StartWerteSetzen
	
Width 100,70	
  Print ""	
  Print "                               "&Chr(178)&Chr(178)	
  Print "   CONWAY's Spiel des Lebens     "&Chr(178)&Chr(178)
  Print "   ------------------------- "&Chr(178)&Chr(178)&Chr(178)&Chr(178)&Chr(178)&Chr(178)
  Print ""	
  Print "Bedeutung und Regeln : https://de.wikipedia.org/wiki/Conways_Spiel_des_Lebens"
  Print "Programmer           : Klaus Brock    klausbrock@hotmail.de       02/2017"
  Print ""	
	
  'phys. Bildschirmaufloesung :	
  SCREENINFO scrb,scrh,scrct
  Print "Ihre Bildschirmaufloesung b * h * Farbtiefe : " ;scrb;" * ";scrh;" * ";scrct
  
  'Setzen physische Fensterbreite u. -hoehe und Zellengroesse (alles als Pixelanzahlen)
  Print ""
  INPUT "Grafik-Fensterbreite ( Default b    ) in Pixeln   : "; ib
  If ib = 0 Or ib > scrb Then
    ib  = scrb
  EndIf  
  INPUT "Grafik-Fensterhoehe  ( Default h-30 ) in Pixeln   : "; ih
  If ih = 0 Or ih > scrh Then
    ih  = scrh - 30  'etwas Platz um die Taskleiste zu erreichen
  EndIf  
  Input "Zellenhoehe in Pixeln ( Default 10 / min 2 )      : "; iz 
  If iz = 0 Then
    iz  = 10
  EndIf  
  If iz < 2  Then
    iz  = 2
  EndIf  
  
  'Ermitteln logische Fenstergroesse  (Anzahl Zellen senkrecht und waagerecht)
  'Anpassen der phys. Fenstergroesse an groesstmoegl. ganzahlige Zellenanzahl 
  '...man muss sich also keine Sorgen machen bei der Angabe der phys. Fenstergroesse !
  Print ""
  Print "Auf ganzzahlige Zellenanzahl angepasste Spielfeldgroesse (Pixel) :"
  ib = ib - ib Mod (iz+1) 'math. Remainder
  Print "  Grafik-Fensterbreite in Pixeln angepasst = "; ib
  ih = ih - ih Mod (iz+1) 'math. Remainder 
  Print "  Grafik-Fensterhoehe  in Pixeln angepasst = "; ih 
      
  'das  ergibt dann eine logische Spielgattergroesse von  lb x lh Zellen,
  ' stellt sicher, dass immer eine ganzzahlige Anzahl Felder im Spieleraster ist :
  Print "daraus resultierende Spielfeldgroesse (Zellen) :"
  lb = ib \ (iz+1) 'math. Floor  
  Print "  log. Spielfeldbreite in Zellen = Spalten = "; lb 
  lh = ih \ (iz+1) 'math. Floor  
  Print "  log. Spielfeldhoehe  in Zellen = Zeilen  = "; lh 
  
  'Spielfeldeigenschaften bei Ranueberschreitungen :
  Print ""
  Print "Spielfeldeigenschaften bei Randueberschreitungen : "
  Print "-------------------------------------------------- "
  Print "- Torus oben/unten + links/rechts (Default) "  
  Print "  - Zellen, die links hinausgehen, kommen rechts wieder herein"
  Print "  - Zellen, die oben hinausgehen, kommen unten wieder herein"
  Print "                             ...und jeweils umgekehrt        --> 1"
  Print "- kein Torus, ausserhalb des Spielfeldes werden"
  Print "                     alle Zellen als tot betrachtet          --> 2"
  Print "- Torus nur oben/unten (links/rechts=Zelltod)                --> 3"
  Print "- Torus nur links/rechts (oben/unten=Zelltod)                --> 4"
  Input "Bitte die Spielfeldeigenschaft waehlen  : "; Splfd
  If Splfd = 0 Then
     Splfd = 1
  ElseIf Splfd > 4 Then
     Splfd = 1
  Else
  EndIf
    
  ' Hier Regeltyp abfragen    /  Regel-  Ziffern fuer ueberleben/geboren
  Print ""
  Print "RegelTypen : "
  Print "------------ "
  Print "  Conway klassisch 23/3 (Default) --> RegelTyp 1"
  Print "  Kopierwelt     1357/1357        --> RegelTyp 2"
  Print "  frei definiert  l../b..         --> RegelTyp 3"
  Input "Bitte den RegelTyp waehlen  : "; RegelTyp
  If RegelTyp= 0 Then
     RegelTyp = 1
  ElseIf RegelTyp= 3 Then
  	  Print "  Kurzschreibweise fuer die Regeln von Game of Life: (Wikipedia) "
  	  Print "    Man setzt zunaechst (in aufsteigender Reihenfolge) die Ziffern der Anzahl "
  	  Print "    von Nachbarn aneinander, bei der eine Zelle ueberlebt, und anschliessend, "
  	  Print "    durch einen Schraegstrich abgetrennt, die Ziffern, die den Werten entsprechen," 
  	  Print "    bei der eine Zelle geboren wird.  "
     Input "  max. 8 Ziffern 0-8 (durch Komma getrennt) fuer die Ueberlebensregel eingeben : "_
        ,ueberleb(1),ueberleb(2),ueberleb(3),ueberleb(4),ueberleb(5),ueberleb(6)_
        ,ueberleb(7),ueberleb(8)
     Input "  max. 8 Ziffern 0-8 (durch Komma getrennt) fuer die Geburtsregel eingeben : "_
        ,neugebor(1),neugebor(2),neugebor(3),neugebor(4),neugebor(5),neugebor(6)_
        ,neugebor(7),neugebor(8)
     For ireg = 2 To 8
     	 If ueberleb(ireg) = 0 Then
     	 	 ueberleb(ireg) = -1
     	 EndIf
     	 If neugebor(ireg) = 0 Then
     	 	 neugebor(ireg) = -1
     	 EndIf     	 
     Next
     Print "  gewaehlte Conway-Regelwelt : ";
       For ireg = 1 To 8
       	If ueberleb(ireg) > -1 Then
       		Print ueberleb(ireg);
       	EndIf
       Next ireg
       Print " /";
       For ireg = 1 To 8
       	If neugebor(ireg) > -1 Then
       		Print neugebor(ireg);
       	EndIf
       Next ireg
       Print ""  
  ElseIf RegelTyp> 3 Then
     RegelTyp = 1
  Else 
  EndIf 
  
    'Zwischenstopp aller wieviel Generationen, 0 fuer Endloslauf 
  Print ""  
  Print "Zwischenstopps :  Vielfache von 4 sind sinnvoll fuer KopierWelt (RegelTyp 2)"
  Print "--------------"
  Input "  Zwischenstopp aller wieviel Generationen ? ( ENTER fuer keinen ) : "; istop
  'If istop = "" Then
  '  istop  = 0
  'EndIf  
    
  ' Hier Verzoegerung nach jeder Generation :
  Print ""
  Print "Verzoegerung nach jeder Generation (zur besseren Sichtbarkeit):"
  Print "----------------------------------"
  Print "  keine Verzoegerung                             :  0"
  Print "  Standard-Verzoegerung (abhaeng. von Zellanzahl :  1"
  Print "  Angabe der Verzoegerung in Millisek.           : nnn"
  Input "Bitte die Verzoegerung waehlen  : "; Vzmillsek
  If Vzmillsek = 1 Then
     Vzmillsek = ((1921-lb) * (1001-lh)) / 30000 
     Print "Stanard-Verzoegerung in Millisek.: ";Vzmillsek
  EndIf    
  
  ' nun noch die Farbanzahlen :
  Print ""  
  input "Bitte die Farbanzahl eingeben 1 - 13 ( Default 1 ) : "; fanz 
  If fanz= 0 Then
     fanz= 13
  ElseIf fanz>13 Then
    fanz=13
  Else  
  EndIf 
  
  ' ... to do :
  Print ""
  Print "jetzt kann gemalt werden :"
  Print "--------------------------"
  Print "- Markiere nun im Grafikfenster die anfangs lebenden Zellen per Mouse-Klick LINKS"
  Print "- Korrekturen von irrtuemlich belebten Zellen sind mit Mouse-Klick RECHTS moeglich"
  Print "- Linienzeichnen :  m vor dem Beleben einer Zelle druecken, dann ab dieser zuletzt"
  Print "  per Mouse-Klick belebten Zelle : Cursor-Tasten verwenden u. ESCape = Ende des Zeichnens"
  Print "- fertig ? - weiter mit Leertatse ins Grafik-Window wechseln" 
  Print "           - STOP der Grafikanzeige mit S-Taste, wird danach fortgesetzt"  
  Print "           - im STOP-Zustand die A-Taste druecken --> Abbruch akt. Spiel, weiter mit neu zeichnen"
  Print "           - im STOP-Zustand die C-Taste druecken --> CANCEL des Programms"
  Print ""
  Print "  ===> bitte eine Taste druecken, um die Grafikanzeige zu oeffnen !"
  Sleep
  
End Sub


Sub GitterLinienZeichnen 
  
  'Zeichnen des Spielegatters / hellgraue Linien  gemaess lh und lb + 1 Pixel fuer die Gitterlinie selbst
  ScreenRes ib, ih, 8    ' Bildschirmmodus breit x hoch bei 8bpp
  ScreenControl 100,0,0  ' Bildschirmposition SET_WINDOW_POS ganz links oben
  Color lincolor,backcolor 
  cls
  WindowTitle "CONWAYs Spiel des Lebens /RegTyp=" & RegelTyp & " Gen=" & igen
  ' erst die waagerechten :
  For i=0 to ih Step iz+1
    Line(1,i)-(ib,i),lincolor 
  Next i  
  ' jetzt die senkrechten :
  For i=0 to ib Step iz+1
    Line(i,1)-(i,ih),lincolor 
  Next i  
  'Mittelpunktsmarkierung :
  Circle(ib/2,ih/2),iz,circolor
  
End Sub


Sub BelebteZellenInit
  
  'internes Ziffern-Array in Grundstellung bringen, das ist das aktuelle Arbeitsfeld :
  For i=1 To lh            'log. Hoehe   (Zeilen)
    For j=1 To lb          'log. Breite  (Spalten)V
      numW(i,j) = FALSE
    Next j
  Next i   
  'Setzen der anfaenglich belebten Zellen per Mouse :
  Do
    'Mouse-Koordinaten im Grafik-Fenster ermitteln : 
    GetMouse (MousePosX, MousePosY, , MouseKeyState)    'Mausstatus abfragen
    breit=MousePosX
    hoch =MousePosY
    'wurde Linie-Malen (m) oder Ende (Space) angefordert ? 
    Taste=InKey       
    If Taste = "m" Or Taste = Chr(27) Then 'diese beiden Werte an Pfeilsteuerung
       Pfeil = Taste
    EndIf
    'aus den Mouse-Koordinaten den zugehoerigen Index i,j  fuer das interne numerische Array errechnen:
    i = hoch  \ (iz+1) +1
    j = breit \ (iz+1) +1
    'Zelle beleben im internen Array und im Gatter, linke Mouse-Taste : 
    If MouseKeyState And 1 Then
    	numW(i,j) = TRUE 
      ZellGeburtInit() 
      'wurde MALEN einer Linie ab der soeben belebten Zelle 
      '   mit den Cursortasten (Tastetasten) angefordert ? :
      If Pfeil = "m" Then ' m fuer Malvorgang starten
        Do
        	 Pfeil = InKey 
      	 If Pfeil = Chr(255,72) then 'nach oben
             i = i - 1
          EndIf
          If Pfeil = Chr(255,75) then 'nach links
             j = j - 1
          EndIf
          If Pfeil = Chr(255,77) then 'nach rechts
             j = j + 1
          EndIf
          If Pfeil = Chr(255,80) then 'nach unten
             i = i + 1
          EndIf
          If Pfeil <> " " Then 'eine Cursortatse wurde verwendet, also Linie in diese Richtung      
         	numW(i,j) = TRUE 
            ZellGeburtInit() 
          EndIf 
        Loop Until Pfeil = Chr(27) 'ESCape fr Verlassen des Malens 
      EndIf  
    EndIf
    'eine irrtuemlich belebte Zelle korrigieren, rechte Mouse-Taste :
    If MouseKeyState And 2 Then
    	numW(i,j) = FALSE
    	ZellTod()  
    EndIf
  'Ende der Markierungen per Leertaste :
  Loop until Taste = " "
  
End Sub


Sub MainLoop
  
  ' ... und hier geht's nun wirklich los !!!
  '      ------------------------------------
  '
  'einmalige Uebernahme des soeben per Mouse befllten Spielegatters :
  For i=1 To lh            'log. Hoehe   (Zeilen)
   For j=1 To lb          'log. Breite  (Spalten)V
     numFolg(i,j) = numW(i,j)    'auf aktuellen Stand bringen ( 0=Tod 1 Geburt inFolgGen) 
   Next j
  Next i 
  '
  Do             '  gewollte Endlosschleife (s.LOOP)
    ' --- Start der aktuellen Generation :  ---
    WindowTitle "CONWAYs Spiel des Lebens /RegTyp=" & RegelTyp & " Gen=" & igen 
    lebend = 0          '  fuer Erkennung auf "alle ausgestorben" nach dieser Generation
    For i=1 To lh
      For j=1 To lb
        CountLivingNeigbors()
        If RegelTyp=1 Then
          KlassischConway()
        ElseIf RegelTyp=2 Then
          KopierWelt()
        ElseIf RegelTyp=3 Then
          FreiDefWelt()
        Else  
          'falscher RegelTyp, kann hier nicht vorkommen
        EndIf  
        ' ********** hier sind noch andere Regelwelten moeglich !!!!!!!!!!!!!
        If numW(i,j) = TRUE Then
          lebend = lebend + 1    ' Zaehlung derzeit lebende Zellen je Generation
        EndIf  
      Next j
    Next i
    '
    ' --- Ender der aktuellen Generation :  ---
    'internes Ziffern-Array fuer Geburt/Tod verarbeiten, also aktuelles numerisches Array 
    'aktualisieren und Grafik zeichnen :
    fndx = (igen Mod fanz) +1  'math. Remainder
    If fndx>13 Then
    	fndx=13
    EndIf
    For i=1 To lh              'log. Hoehe   (Zeilen)
      For j=1 To lb            'log. Breite  (Spalten)
        If numW(i,j) Xor numFolg(i,j) = TRUE Then   '3=unveraendert in Folgegen. ( 0=Tod 1 Geburt inFolgGen) 
          numW(i,j) = numFolg(i,j)
          If numW(i,j) = FALSE Then
            ZellTod()
          EndIf  
          If numW(i,j) = TRUE Then 
            ZellGeburt()    'gefuelltes Rechteck Farbe lebend gem. Generation
          EndIf   
        EndIf  
      Next j
    Next i
    ' Verzoegerung :
    Sleep Vzmillsek
    ' wurde Nutzerstop angefordert per "s" ?
    StopKey()
    ' ... oder sind etwa alle ausgestorben ?  Dann Programmende !
    Ausgestorben()
    'wurde ein Zwischenstopp angefordert ? ( sinnvoll ist 4 in sog. "Kopierwelt" )
    If istop > 0 Then
    	IF igen Mod istop = 0 Then
        Sleep
      EndIf  
    EndIf  
    igen = igen+1
    Steuer = InKey
    If Steuer = "c" Or Steuer = "C" Then
    	End
    EndIf
  Loop until ( Steuer = "a" Or Steuer = "A" )  ' A = Abbruch
  
End Sub


'-------------------  es folgen   Level   2   Sub's ----------------------------------------------------------


Sub CountLivingNeigbors
  'Hier werden die lebendigen Nachbarzellen der betrachteten Zelle gezaehlt. ( 3 x 3 ) 
  ' "TORUS" bedeutet :
  'Bei OUT OF RANGE eines Nachbarn, also direkt am Rand des Spielegatters, wird die sich
  ' jeweils am genueberliegenden Rand befindliche Zeile/Spalte herangezogen.
  'Damit wird eine Quasi-Endlosigkeit des Spielfeldes vorgetaeuscht...
  LivNbrs = 0
  For k=i-1 To i+1
    For l=j-1 To j+1
    	 ' es darf ber den Spielfeldrand gezhlt werden ( Standard fr Splfd 1 )
    	 cnt=TRUE
       ' Normalfall im Spielfeld ohne Randueberschreitungen (Out Of Range) :
       m=k
       n=l
       ' Out Of Range / Ueberschreitung links,rechts u. oben,unten = 4 Faelle abhandeln :
       ' ------------------------------------------------------------------------------
       'Fall 1 : TORUS links/rechts UND oben/unten (eine solche Flche ist in der Realitaet nicht moeglich )
       If Splfd = 1 Then         
         If k<1 Then  'Zeile
           m=lh
         EndIf
         If k>lh Then
           m=1
         EndIf
         If l<1 Then  'Spalte
           n=lb
         EndIf
         If l>lb Then
           n=1
         EndIf
       'Fall 2 : kein TORUS, Randueberschreitung = ZellTod  
       ElseIf Splfd = 2 Then      
         If k<1 Then  'Zeile
           m=1
           cnt=FALSE
         EndIf
         If k>lh Then
           m=lh
           cnt=FALSE
         EndIf
         If l<1 Then  'Spalte
           n=1
           cnt=FALSE
         EndIf
         If l>lb Then
           n=lb
           cnt=FALSE
         EndIf
       'Fall 3 : TORUS NUR oben/unten  ( links/rechts=ZellTod )
       ElseIf Splfd = 3 Then 
         If k<1 Then  'Zeile
           m=lh
         EndIf
         If k>lh Then
           m=1
         EndIf
         If l<1 Then  'Spalte
           n=1
           cnt=FALSE
         EndIf
         If l>lb Then
           n=lb
           cnt=FALSE
         EndIf       	
       'Fall 4 : TORUS NUR links/rechts ( oben/unten =ZellTod ) 	
       ElseIf Splfd = 4 Then
         If k<1 Then  'Zeile
           m=1
           cnt=FALSE
         EndIf
         If k>lh Then
           m=lh
           cnt=FALSE
         EndIf
         If l<1 Then  'Spalte
           n=lb
         EndIf
         If l>lb Then
           n=1
         EndIf       	
       Else ' nicht moeglich
       EndIf
       ' Zaehlung lebende Nachbarzellen :    
       If cnt = TRUE  And  numW(m,n) = TRUE Then 
         LivNbrs = LivNbrs + 1
       EndIf       
    Next l
  Next k
  If numW(i,j) = TRUE Then  
    LivNbrs=LivNbrs-1 'die betrachtete Zelle selbst wird NICHT mit gezaehlt, falls sie lebt !
  EndIf 
End Sub


Sub KlassischConway
  'klassische CONWAY-Regeln :
  '-----------------------------------
  ' tot, aber genau 3 lebende Nachbarn :
  If numW(i,j) = FALSE and LivNbrs = 3 then
    numFolg(i,j) = TRUE    ' Vormerken Geburt in Folgegen.
  EndIf
  ' lebend, aber weniger als 2 lebende Nachbarn :
  If numW(i,j) = TRUE and LivNbrs < 2 then  'Tod durch Einsamkeit
    numFolg(i,j) = FALSE   ' Vormerken Absterben in Folgegen.
  EndIf 
  ' lebend, aber mehr als 3 lebende Nachbarn :
  If numW(i,j) = TRUE and LivNbrs > 3 then  'Tod durch Überbevoelkerung 
    numFolg(i,j) = FALSE   ' Vormerken Absterben in Folgegen. 
  EndIf 
  ' lebend mit 2 oder 3 lebenden Nachbarn bleibt am Leben.
End Sub            


Sub KopierWelt
  ' Kopierwelt  ( Anzahl lebender Nachbarn Modulo 2 ) :
  '-----------------------------------
  If LivNbrs Mod 2 = 0 Then 'math. Remainder
    numFolg(i,j) = FALSE    ' Vormerken Absterben bei 0,2,4,6,8 leb.Nachbarn in Folgegen.
  Else
    numFolg(i,j) = TRUE     ' Vormerken Geburt bei 1,3,5,7 leb.Nachbarn  in Folgegen.
  EndIf 
End Sub  


Sub FreiDefWelt
  'frei definierbare Welt llll/bbbb anhand der Ueberlebensregel l und der Geburtsregel b  :
  '----------------------------------------------------------------------------------------
  'Hinweis : nicht eingegebene Werte werden nach dem input auf -1 gestellt ( keine 0 mehr ) !
  '
  ' Start-Annahme :
  numFolg(i,j) = FALSE  ' Vormerken Absterben in Folgegen.
  ' ueberlebend ? :
  If numW(i,j) = TRUE Then
    For ireg = 1 To 8
      If LivNbrs = ueberleb(ireg)  Then
        numFolg(i,j) = TRUE   ' Vormerken Geburt in Folgegen.
        Continue For
      EndIf
    Next ireg 
  EndIf  
  ' Geburt ? :
  If numW(i,j) = FALSE Then
    For ireg = 1 To 8
      If LivNbrs = neugebor(ireg)  then
        numFolg(i,j) = TRUE   ' Vormerken Geburt in Folgegen.
        Continue for
      EndIf
    Next ireg 
  EndIf  
End Sub


Sub ZellGeburtInit
  'eine bisher leblose Zelle wird belebt ( im numerischen Array und im Gatter )
  liox = (j-1)*(iz+1) + 1   ' +1 ist die Gitternetzlinie
  lioy = (i-1)*(iz+1) + 1   ' +1 ist die Gitternetzlinie 
  reux = liox + (iz-1)
  reuy = lioy + (iz-1)
  Line(liox,lioy)-(reux,reuy),lebcolor,BF  'gefuelltes Rechteck Farbe lebend INIT
End Sub 


Sub ZellTod
  ZellPos()
  Line(liox,lioy)-(reux,reuy),totcolor,BF  'gefuelltes Rechteck Farbe tot INIT
End Sub 


Sub ZellGeburt
  'eine bisher leblose Zelle wird belebt ( im numerischen Array und im Gatter )
  ZellPos()
  Line(liox,lioy)-(reux,reuy),Farbe(fndx),BF  'gefuelltes Rechteck Farbe lebend INIT
End Sub 


Sub ZellPos
  liox = (j-1)*(iz+1) + 1   ' +1 ist die Gitternetzlinie
  lioy = (i-1)*(iz+1) + 1   ' +1 ist die Gitternetzlinie 
  reux = liox + (iz-1)
  reuy = lioy + (iz-1)	
End Sub


Sub StopKey
  ' Stop game   
  If InKey = "s" Or InKey = "S" Then
  	 WindowTitle "CONWAYs Sp... /RegTyp=" & RegelTyp & " Gen=" & igen & " Stop ! ( C = Abbruch / A = neu zeichnen )"
  	 Sleep
  EndIf
End Sub 


Sub Ausgestorben
  ' ... alle ausgestorben :
  If lebend = 0 Then
  	 WindowTitle "CONWAYs Spiel des Lebens /RegTyp=" & RegelTyp & " Gen=" & igen & " alle AUSGESTORBEN !" 
    Sleep
    i = i / 0
  EndIf  
End Sub  


Sub ShowArray
  ' NUR zu Testzwecken  Ausgabe des kompletten numerischen Arrays
  For ix=1 To lh
    For jx=1 To lb
      if numW(ix,jx)= TRUE Then
        Print "1"
      Else 
        Print "0"
      EndIf     
    Next jx
    Print ""
  Next ix 
End Sub